###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2008 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################
%define buildup 1
%define buildsmp 1
%define buildhugemem 1
%define buildlargesmp 1
%define buildxen 1
%define kernel_version 2.6.9-89.0.9.EL
%define subversion 58

%ifnarch i686 x86_64
%define buildsmp 0
%define buildxen 0
%endif 

%ifnarch i686
%define buildhugemem 0
%endif

%ifnarch x86_64 ia64 ppc64
%define buildlargesmp 0
%endif

Name: dlm-kernel
Version: 2.6.9
Release: %{subversion}.6%{?dist}.5
License: GPL
Group: System Environment/Kernel
Summary: dlm-kernel - The Distributed Lock Manager kernel modules.
BuildRequires: cman-kernheaders >= 2.6.9
BuildRequires: kernel-devel = %{kernel_version}
BuildRequires: cman-kernel >= 2.6.9

%if %{buildsmp}
BuildRequires: kernel-smp-devel = %{kernel_version}
BuildRequires: cman-kernel-smp >= 2.6.9
%endif

%if %{buildhugemem}
BuildRequires: cman-kernel-hugemem >= 2.6.9
BuildRequires: kernel-hugemem-devel = %{kernel_version}
%endif

%if %{buildlargesmp}
BuildRequires: kernel-largesmp-devel = %{kernel_version}
BuildRequires: cman-kernel-largesmp >= 2.6.9
%endif

%if %{buildxen}
BuildRequires: kernel-xenU-devel = %{kernel_version}
BuildRequires: cman-kernel-xenU >= 2.6.9
%endif

Conflicts: GFS <= 6.0
Conflicts: GFS-modules GFS-module-smp GFS-module-hugemem
Requires: kernel = %{kernel_version}
Requires: cman-kernel >= 2.6.9
Requires: /lib/modules/%{kernel_version}
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}
ExclusiveArch: i686 ia64 x86_64 ppc64
Source0: %{name}-%{version}-%{subversion}.tar.gz
Patch0: bz515453.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dlm-kernel - The Distributed Lock Manager kernel modules.

%package -n dlm-kernheaders
Group: Development/System
Summary: dlm kernel header files

%description -n dlm-kernheaders
The dlm kernel headers are used by various cluster packages.

%if %{buildsmp}
%package -n dlm-kernel-smp
Group: System Environment/Kernel
Summary: dlm-kernel-smp - The Distributed Lock Manager kernel modules.
Requires: kernel-smp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}smp
Requires: cman-kernel-smp >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-smp
dlm-kernel-smp - The Distributed Lock Manager kernel-smp modules.
%endif

%if %{buildhugemem}
%package -n dlm-kernel-hugemem
Group: System Environment/Kernel
Summary: dlm-kernel-hugemem - The Distributed Lock Manager kernel modules.
Requires: kernel-hugemem = %{kernel_version}
Requires: /lib/modules/%{kernel_version}hugemem
Requires: cman-kernel-hugemem >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-hugemem
dlm-kernel-hugemem - The Distributed Lock Manager kernel-hugemem modules.
%endif

%if %{buildlargesmp}
%package -n dlm-kernel-largesmp
Group: System Environment/Kernel
Summary: dlm-kernel-largesmp - The Distributed Lock Manager kernel modules.
Requires: kernel-largesmp = %{kernel_version}
Requires: /lib/modules/%{kernel_version}largesmp
Requires: cman-kernel-largesmp >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-largesmp
dlm-kernel-largesmp - The Distributed Lock Manager kernel-largesmp modules.
%endif

%if %{buildxen}
%package -n dlm-kernel-xenU
Group: System Environment/Kernel
Summary: dlm-kernel-xenU - The Distributed Lock Manager kernel modules.
Requires: kernel-xenU = %{kernel_version}
Requires: /lib/modules/%{kernel_version}xenU
Requires: cman-kernel-xenU >= 2.6.9
Provides: kernel-modules
Provides: dlm-kernel-modules = %{version}-%{release}

%description -n dlm-kernel-xenU
dlm-kernel-xenU - The Distributed Lock Manager kernel-xenU modules.
%endif

################################################################################
##  THE PREP SECTION
################################################################################
%prep
%setup -q -n %{name}-%{version}-%{subversion}
sed  -i -e '/RELEASE_NAME/s/"<CVS>"/"%{version}-%{release}"/' \
       src/dlm_internal.h	
%patch0 -p2 -b .bz515453

################################################################################
##  THE BUILD SECTION
################################################################################
%build

ROOT_DIR_FILES=`ls`
mkdir up
mv  $ROOT_DIR_FILES up
cp -r up smp
cp -r up hugemem
cp -r up largesmp
cp -r up xenU

Build_dlm(){
	cpu_type=$1
	flavor=$2
	kernel_src=/lib/modules/%{kernel_version}$flavor/build/
	# Kernel tree setup
	if [ -d $kernel_src/. ]; then
		echo "Kernel %{kernel_version} found."
		echo $kernel_src
	else
		echo "Kernel %{kernel_version} not found."
		echo $kernel_src
		ls /lib/modules/*
		exit 1
	fi

	./configure --kernel_src=$kernel_src --incdir=%{_includedir}
	make symverfile=/lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
	ls -l /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers
	$kernel_src/scripts/mod/modpost -m -i /lib/modules/%{kernel_version}$flavor/kernel/cluster/cman.symvers src/dlm.o -o dlm.symvers
}

%if %{buildup}
cd up
Build_dlm %{_target_cpu}
cd ..
%endif

%if %{buildsmp}
cd smp
Build_dlm %{_target_cpu} smp
cd ..
%endif

%if %{buildhugemem}
cd hugemem
Build_dlm %{_target_cpu} hugemem
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
Build_dlm %{_target_cpu} largesmp
cd ..
%endif

%if %{buildxen}
cd xenU
Build_dlm %{_target_cpu} xenU
cd ..
%endif

################################################################################
##  THE INSTALL SECTION
################################################################################
%install
rm -rf $RPM_BUILD_ROOT

%if %{buildup}
cd up
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/kernel/cluster/
cd ..
%endif
                                                                                
%if %{buildsmp}
cd smp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}smp/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}smp/kernel/cluster/
cd ..
%endif

%if %{buildhugemem}
cd hugemem
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}hugemem/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}hugemem/kernel/cluster/
cd ..
%endif

%if %{buildlargesmp}
cd largesmp
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}largesmp/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}largesmp/kernel/cluster/
cd ..
%endif

%if %{buildxen}
cd xenU
make install DESTDIR=$RPM_BUILD_ROOT symverfile=/lib/modules/%{kernel_version}xenU/kernel/cluster/cman.symvers
install dlm.symvers $RPM_BUILD_ROOT/lib/modules/%{kernel_version}xenU/kernel/cluster/
cd ..
%endif

################################################################################
##  THE CLEAN SECTION
################################################################################
%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/depmod -e %{kernel_version}

%if %{buildsmp}
%post smp
/sbin/depmod -e %{kernel_version}smp
%endif

%if %{buildhugemem}
%post hugemem
/sbin/depmod -e %{kernel_version}hugemem
%endif

%if %{buildlargesmp}
%post largesmp
/sbin/depmod -e %{kernel_version}largesmp
%endif

%if %{buildxen}
%post xenU
/sbin/depmod -e %{kernel_version}xenU
%endif

%files
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}/kernel/cluster/*

%if %{buildsmp}
%files -n dlm-kernel-smp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}smp/kernel/cluster/*
%endif

%if %{buildhugemem}
%files -n dlm-kernel-hugemem
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}hugemem/kernel/cluster/*
%endif

%if %{buildlargesmp}
%files -n dlm-kernel-largesmp
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}largesmp/kernel/cluster/*
%endif

%if %{buildxen}
%files -n dlm-kernel-xenU
%defattr(-,root,root,-)
/lib/modules/%{kernel_version}xenU/kernel/cluster/*
%endif

%files -n dlm-kernheaders
%defattr(-,root,root,-)
%{_includedir}/cluster/*

%changelog
* Thu Aug 20 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.9.EL
- Resolves: rhbz#518505

* Tue Aug 11 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.7.EL
- Resolves: rhbz#516926

* Wed Aug 05 2009 Chris Feist <cfeist@redhat.com>
- A bug which could cause 'ls' to hang has been fixed.
- Resolves: rhbz#515453

* Wed Jul 08 2009 Chris Feist <cfeist@redhat.com>
- Build for kernel-2.6.9-89.0.3.EL
- Resolves: rhbz#510075

* Tue May 05 2009 Chris Feist <cfeist@redhat.com>
- Built for kernel-2.6.9-89.EL

* Wed Feb 04 2009 Chris Feist <cfeist@redhat.com>
- Now using __module_get() instead of module_get to prevent dlm module unload.
- Resolves: rhbz#467040

* Thu Jan 29 2009 Chris Feist <cfeist@redhat.com>
- Increase the default lock timeout to prevent userspace applications from
  failing when the system load is high.
- Prevent the dlm module from being force unloaded during an emergency shutdown.
- Resolves: rhbz#247766

* Mon Dec 15 2008 Chris Feist <cfeist@redhat.com>
- The lock_info struct is now not freed if a lock conversion fails.
- Ensure lockspace name is null terminated.
- Resolves: rhbz#458762 rhbz#466498

* Tue Apr 15 2008 Chris Feist <cfeist@redhat.com>
- Option has been added to disable the TCP nagle algorithm which can cause
  delays in lock traffic
- Resolves: rhbz#244708

* Thu Nov 08 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-67.EL kernel

* Wed Nov 07 2007 Chris Feist <cfeist@redhat.com>
- Fixed an issue caused by a lock master sending an async "granted" message
  for a convert reqeust before sending a reply for the original convert.
- Resolves: rhbz #349001

* Wed Oct 31 2007 Chris Feist <cfeist@redhat.com>
- dlm-kernel now sets the source address for outgoing packets to the node ip
  address, instead of allowing the kernel to pick the source address.
- Resolves: rhbz #338511

* Wed Oct 24 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-65.EL kernel

* Wed Oct 10 2007 Chris Feist <cfeist@redhat.com>
- Fixed deadlock when starting up clvmd.
- Resolves: rhbz#318851

* Mon Oct 01 2007 Chris Feist <cfeist@redhat.com>
- When closing a device dlm now tries harder to release all locks
- Fixed a DLM locking assertion failure (line 1390)
- Resolves: rhbz#280161 rhbz#240453 rhbz#238490

* Thu Sep 13 2007 Chris Feist <cfeist@redhat.com>
- When we close a device we try harder to close all held locks.
- Resolves: rhbz#280161

* Mon Aug 20 2007 Chris Feist <cfeist@redhat.com>
- Disable xen until kernel is fixed

* Fri Aug 17 2007 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-56.EL kernel
- Fixed crash when running 'cat /proc/cluster/dlm_locks'
- Fixed dlm hang when tcp connection was opened to dlm port
- Fixed DLM locking assertion failure on line 139
- Resolves: rhbz#240356 rhbz#245828 rhbz#240453

* Fri Jan 12 2007 Chris Feist <cfeist@redhat.com>
- Built for xenU kernel

* Wed Dec 20 2006 Chris Feist <cfeist@redhat.com>
- Built for 2.6.9-42.0.4.EL kernel

* Fri Apr 21 2006 Chris Feist <cfeist@redhat.com>
- Added support for largesmp kernel.

* Tue May 17 2005 Chris Feist <cfeist@redhat.com>
- Provide dlm-kernel-modules.

* Mon May 16 2005 Chris Feist <cfeist@redhat.com>
- Add depmod in %post scriplet.

* Fri May 06 2005 Chris Feist <cfeist@redhat.com>
- Cleaned up .spec file. 

* Mon Dec 20 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Fri Dec 10 2004 Chris Feist <cfeist@redhat.com>
- Build for new kernel & upstream fixes.

* Thu Nov 18 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Fri Oct 22 2004 Chris Feist <cfeist@redhat.com>
- various bug fixes (new upstream sources)

* Mon Aug 16 2004 Jon Brassow <jbrassow@redhat.com>
- add requires field

* Sat Aug 14 2004 Jon Brassow <jbrassow@redhat.com>
- smp was building but not being packaged
- specify more packages that conflict with this one

* Fri Aug 13 2004 Jon Brassow <jbrassow@redhat.com>
- various bug fixes (new upstream sources)
- no need for make file patch

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- update patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- add patch for a Makefile

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- be more explicit in files section

* Wed Jul 14 2004 Jon Brassow <jbrassow@redhat.com>
- bump rev number and fix typo

* Thu Jun 17 2004 Jon Brassow <jbrassow@redhat.com> 
- Initial build.
